<?php

function OpenGeoDB() {
  global $geodbfh;
  
  $geodbfh = fopen('ip2region.db', 'rb');
  if (!$geodbfh) throw new Exception("Couldn't find database file");
}

function CloseGeoDB() {
  global $geodbfh;

  fclose($geodbfh);
}

function RegionByIP($ip) {
  global $geodbfh;

  $offset = 0;
  foreach (explode('.', $ip) as $part) {
    $part = (int)$part;
    $start = $offset + (int)$part * 4;
    fseek($geodbfh, $start, 0);
    $value = fread($geodbfh,  4);
    if (substr($value, 0, 2) == "\xFF\xFF") {
      if (($code = substr($value, 2, 2)) == "\x00\x00") {
        return ''; # No IP in database
      }
      else {
        $code = unpack('S', $code);
        return $code[1];
      }
    }
    print $value;
    $offset = unpack("N", $value);
    $offset = $offset[1];
  }
  return '';
}
OpenGeoDB();
//$ip ='82.209.192.1'; // 1
$ip = '82.209.239.64'; // 6

$code =  RegionByIP($ip);
if ($code) {
  print "$ip located in $code region\n";
}
else {
  print "$ip not found in database\n";
}
CloseGeoDB();
?>

